#include "ds1621.h"	

void ds1621_init(void)
{
	//i2c_init();										// IC initialisieren
	i2c_start_wait(DS1621_ADRESSE+I2C_WRITE);		// DS1621-Adresse + Zugriffmodus
   	i2c_write(0xAC);								// Code fr Temperatur lesen 
   	i2c_write(0x03);								// Code fr Temperatur lesen
   	i2c_stop();										// I2C Stop	
	_delay_ms(10);  								// Warten bis Daten im Memory gespeichert sind               
}

float ds1621_get_temp(void)
{
	cli();
	// Messung starten
    i2c_start_wait(DS1621_ADRESSE+I2C_WRITE);		// DS1621-Adresse + Zugriffmodus
    i2c_write(0xEE);								// Code fr Konvertierung starten							                 
    i2c_stop();										// I2C Stop
  	// Temperatur anfordern
    i2c_start_wait(DS1621_ADRESSE+I2C_WRITE);		// DS1621-Adresse + Zugriffmodus
    i2c_write(0xAA);								// Code fr Temperatur lesen                 
    i2c_stop();										// I2C Stop
    // Temperatur abholen
    i2c_rep_start(DS1621_ADRESSE+I2C_READ);			// DS1621-Adresse + Zugriffmodus  
    highbyte = i2c_readAck();						// Hi-Byte lesen, Daten folgen...           
    lowbyte = i2c_readNak();						// Lo-Byte lesen, Stop-Kennung
    i2c_stop();                						// I2C Stop
	_delay_ms(800);									// 800ms warten bis DS1621-Counter und DS1621-Slope bereit
   	i2c_start(DS1621_ADRESSE+I2C_WRITE);			// DS1621-Adresse + Zugriffmodus
   	i2c_write(0xA8);								// Code fr DS1621-Counter auslesen
	i2c_stop();										// I2C Stop
   	i2c_start(DS1621_ADRESSE+I2C_READ);				// DS1621-Adresse + Zugriffmodus
   	rc = i2c_readNak();								// Byte lesen, Stop-Kennung
	i2c_stop();										// I2C Stop
	i2c_start(DS1621_ADRESSE+I2C_WRITE);			// DS1621-Adresse + Zugriffmodus
   	i2c_write(0xA9);								// Code fr DS1621-Slope auslesen
	i2c_stop();										// I2C Stop
   	i2c_start(DS1621_ADRESSE+I2C_READ);				// DS1621-Adresse + Zugriffmodus
   	rs = i2c_readNak();								// Byte lesen, Stop-Kennung
	i2c_stop();										// I2C Stop
	if(lowbyte==128)								// Wenn Flag fr Nachkommastelle gesetzt, ...
	{
		temperatur = (highbyte + 0.5); 				// Kommastelle hinzufgen (Auflsung: 0.5)
		tempk = (temperatur - 0.75);  				// Kommastelle hinzufgen (Auflsung: 0.1)
	}
	else 
	{
		temperatur = highbyte;						// Kommastelle hinzufgen (Auflsung: 0.5)
       	tempk = (temperatur - 0.25);				// Kommastelle hinzufgen (Auflsung: 0.1)
	}
	rk = (rs - rc);         						// 1. Teil-Formel fr Fein-Korrektur
    rk = (rk / rs);         						// 2. Teil-Formel fr Fein-Korrektur
    tempk = (tempk + rk);   						// Ganztemp + Korrekturwert
	float SenX1 = 20.1;
	float RefY1 = 22.1;
	float SenX2 = 12.1;
	float RefY2 = 14.3;
	float m = (RefY2 - RefY1) / (SenX2 - SenX1);
	return (m*(tempk-SenX1)+RefY1);					// Temperatur mit hoher Auflsung zurckgeben
	sei();
}
