#ifndef _I2C_H
#define _I2C_H   1

#ifdef DOXYGEN
#endif

#if (__GNUC__ * 100 + __GNUC_MINOR__) < 304
#error "This library requires AVR-GCC 3.4 or later, update to newer AVR-GCC compiler !"
#endif

#include <compat/twi.h>

#ifndef F_CPU
#define F_CPU 16000000UL
#endif

#define SCL_CLOCK  100000L

#define I2C_READ    1

#define I2C_WRITE   0

void i2c_init(void);
void i2c_stop(void);
unsigned char i2c_start(unsigned char addr);
unsigned char i2c_rep_start(unsigned char addr);
void i2c_start_wait(unsigned char addr);
unsigned char i2c_write(unsigned char data);
unsigned char i2c_readAck(void);
unsigned char i2c_readNak(void);
unsigned char i2c_read(unsigned char ack);

#define i2c_read(ack)  (ack) ? i2c_readAck() : i2c_readNak(); 

#endif
