#include "power.h"
#include "uart.h"
#include "hh10d.h"
#include "ds1621.h"

void standby()
{
	rfm12_sleep();
	atmega_sleep();			
}

void rfm12_sleep()
{
	rfm12_write(0x0000);
	rfm12_write(0x8057);																// Sende-Fifo deaktivieren (Bit el lschen) Wichtig!
	rfm12_write(0x8203);  																// Wakeup aktivieren, Clockoutput aus
	rfm12_write(0xE74E); 			   													// Wakup-Timer 10 Sekunden
}

void atmega_sleep()
{
	SENSOREN_OFF;

	// Geht in die Schlafphase		
	ACSR  |= (1 << ACD);																// Analogcomparator ausschalten
	EIMSK |= (1 << INT0);            													// externen Interrupt freigeben
	set_sleep_mode(SLEEP_MODE_PWR_DOWN);												// Sleep-Modus: PowerDown	    
	sleep_mode();																		// Atmega in den Sleep-Modus schiken		
	
	// Ab hier wieder wach
	EIMSK &= ~(1 << INT0);           													// externen Interrupt sperren				
	rfm12_init();																		// RFM12 initialisieren		
	
	if (TypMode == Sensor)																// Wenn Modul = Sensor
	{
		SENSOREN_ON;																	// Sensoren einschalten
		i2c_init();
		hh10d_init();																	// init HH10D
		ds1621_init();																	// init DS1621
	}																					

}

ISR(INT0_vect)
{
	asm("nop");
}
