#ifndef _RFM12_H
#define _RFM12_H

#include <avr/interrupt.h>
#include <util/delay.h>
#include <string.h>

#include "spi.h"
#include "timer.h"

#define RF12FREQ(freq)	((freq-430.0)/0.0025)
#define rfm12_get_status	rfm12_write(0x0000)
#define rfm12_fifo_reset	rfm12_write(0xCA81);rfm12_write(0xCA83)
#define RFM12_BAUD 4800UL

#define LED1_ON		PORTD |= (1 << PD5)
#define LED2_ON		PORTD |= (1 << PD6)
#define LED1_OFF	PORTD &= ~(1 << PD5)
#define LED2_OFF	PORTD &= ~(1 << PD6)
#define LED1_TOG	PORTD ^= (1 << PD5)
#define LED2_TOG	PORTD ^= (1 << PD6)
#define FAN_ON		PORTD |= (1 << PD4);	
#define FAN_OFF		PORTD &= ~(1 << PD4);	
#define FAN_TOG		PORTD ^= (1 << PD4)

void rfm12_init(void);
void rfm12_setbandwidth(uint8_t, uint8_t, uint8_t);
void rfm12_setfreq(uint16_t);
void rfm12_setbaud(uint16_t);
void rfm12_setpower(uint8_t, uint8_t);
void rfm12_write_data(uint16_t);
uint16_t rfm12_write(uint16_t);
uint8_t rfm12_read(void);
void rfm12_send_text(char *);
void rfm12_get_text(char *);

volatile uint8_t rfm12_fifo_voll;					// ISR Variable
char Adresse[2], PacketEmpfangen;
uint8_t i, PacketLen, BitCounterRec, ReturnWert;

#endif
