#include "spi.h"

void spi_master_init (void) 
{
	uint8_t status;
	DDRB = (1<<PB2) | (1<<PB3) | (1<<PB5);					// setze SCK,MOSI,PB2 (SS) als Ausgang
	DDRB &= ~(1<<PB4);										// setze MISO als Eingang
	PORTB = (1<<PB2) | (1<<PB5);							// SCK und PB2 high (ist mit SS am Slave verbunden)
	
	
	SPCR = (1<<SPE) | (1<<MSTR)  | (1<<SPR0);// | (1<<SPI2X);	// Aktivierung des SPI, Master, Taktrate fck/8			
	status = SPSR;											// Status lschen
}

uint8_t spi_trans_8(uint8_t wert)
{
	PORTB &= ~(1<<PB2);										// SS am Slave Low --> Beginn der bertragung
	SPDR = wert;											// Low-Byte bertragen
	while (!(SPSR & (1<<SPIF)));							// Warten bis bertragung abgeschlossen
	PORTB |= (1<<PB2);										// SS am Slave High --> Ende der bertragung
	return SPDR;											// Rckgabe des empfangenen Words
}

uint16_t spi_trans_16(uint16_t wert)
{
	uint16_t newHigh=0,newLow=0,newWord=0;				
	PORTB &= ~(1<<PB2);										// SS am Slave Low --> Beginn der bertragung
	SPDR = wert >> 8;										// High-Byte bertragen
	while (!(SPSR & (1<<SPIF)));							// Warten bis bertragung abgeschlossen
	newHigh = SPDR;											// Empfangenes High-Byte lesen
	SPDR = wert;											// Low-Byte bertragen
	while (!(SPSR & (1<<SPIF)));							// Warten bis bertragung abgeschlossen
	newLow = SPDR;											// Empfangenes Low-Byte lesen
	PORTB |= (1<<PB2);										// SS am Slave High --> Ende der bertragung
	newWord = (newHigh<<=8) | newLow;						// High-Byte und Low-Byte zusammenfhren	
	return newWord;											// Rckgabe des empfangenen Words
}
