#include "timer.h"

void timer_init(void)
{
	TCCR2A |= (1<<WGM21); 									// CTC Mode Aktivierung Timer2
	TCCR2A |= (1<<COM2B0) | (1<<COM2B1); 					// set OCR Flag bei "Compare Match"
	
	TCCR0B |= (1<<CS02) | (1<<CS01) | (1<<CS00);			// Ext Flanke Interrupt (T0)

	if(F_CPU == 8000000UL)									// Wenn Systemtakt 8 MHz ist
	{		
		TCCR2B |= (1<<CS22) | (1<<CS21);				 	// Prescaler Timer2 auf 256 setzen
		OCR2A  |= 249; 										// Output Compare register Timer2 auf 249 (fr Loop 0-249 => 250)
	}

	if(F_CPU == 16000000UL)									// Wenn Systemtakt 16 MHz ist
	{		
		TCCR2B |= (1<<CS22) | (1<<CS21) | (1<<CS20);		// Prescaler Timer2 auf 1024 setzen
		OCR2A  |= 124; 										// Output Compare register Timer2 auf 124 (fr Loop 0-124 => 125)
	}

	TIMSK2 |= (1<<OCIE2B); 									// Enable comp match flag interrupt Timer 2 
	TIMSK0 |= (1<<TOIE0); 									// Enable overflow flag interrupt Timer 0
}

void timer_reset(void)
{
		count = 0;
		ztmp = 0;
		z = 0;
		TCNT0 = 0;
		counter = 0;
		IntervallSekunde = 0;
}

ISR(TIMER2_COMPB_vect) 										// Frequnezmessung (Lst alle 8ms aus)
{
	if (counter==125)										// Entspricht 1 Sekunde
	{ 
		count = TCNT0;
		ztmp = z;
		z= 0;
		TCNT0 = 0;
		counter = 0;
		IntervallSekunde = 1;
	}

	counter++;
}


ISR(TIMER0_OVF_vect) 										// Eingangsignal Overflow Zhler Timer 0
{
	z++;
	TIFR0 = (1<<TOV0); 										// ov flag timer 0 zurcksetzen
}
