#include "uart.h"
#include "timer.h"

void uart_init(void)
{
	uint8_t x;
	UBRR0L = (F_CPU / (16ul * UART_BAUD))-1;					// Baudrate mit Takt und Baud
	UCSR0B |= (1 << TXEN0) | (1 << RXEN0); 						// Sender und Empnger aktivieren
	UCSR0C |= (1 << UCSZ01) | (1 << UCSZ00);					// async 8bit
	x = UDR0;													// Empfnger leeren
	sbi(UCSR0B,RXCIE0);											// USART-Empfangs-Interrupt aktivieren
}

uint8_t uart_get_byte(void)
{
	while(!(UCSR0A & (1 << RXC0)));								// warten bis Empfang abgeschlossen
	return UDR0;												// Byte abholen
}

void uart_send_byte(uint8_t x)
{
	while(!(UCSR0A & (1 << UDRE0)));							// warten bis Schnittstelle bereit
	UDR0 = x;													// Zu sendendes Byte bergeben
}

void uart_send_text(char *s)
{
    while (*s)													// so lange *s ungleich '\0' (String-Endezeichen)
    {   
        uart_send_byte(*s);										// Byte senden
        s++;													// nchstes Byte whlen
    }
}

ISR(USART_RX_vect)												// USART Empfangs-Interrupt
{	
	uart_data = uart_get_byte();								// Zeichen aus Puffer holen
}

